#!/usr/bin/python3.1
# pythagoras.py
# a GUI for working out pythagoras theorem
#
# Version 3: Further enhancements to GUI
#

# import some modules tkinter for a canvas
from tkinter import *
import math           #for square root function

# the button function
def calcHypotenuse(*ignore):
    #This function takes values for a and b and calculates
    #the value for the hypotenuse (c)
    #
    #formula is (a*a) + (b*b) = (c*c)
    #then need square root
    
    #store values from inputs
    a = value_a.get()
    b = value_b.get()

    #validation of inputs
    #are they integers and not zero?

    if not a.isdigit() or int(a) <= 0:
        message = "Please enter length of side a above 0"
        
    elif not b.isdigit() or int(b) <= 0:
        message = "Please enter length of side b above 0"

    else:
        #if here we have two numbers and both above 0
        asquared = int(a) * int(a)
        bsquared = int(b) * int(b)
        csquared = asquared + bsquared
        c = math.sqrt(csquared) 
        message = str(c)

    display(message)

# text display function
def display(message):
    """Simple text display function. Takes a string."""
    txt["state"] = "normal"
    txt.delete(0.0, END)
    txt.insert(0.0, message)
    txt["state"] = "disabled"

# set up the GUI
root = Tk()
root.resizable(0,0) #stop window from being resized
app = Frame(root)   #create the frame
app.grid()          #use a grid to layout the frame

#bind the calcHypotenuse function to <Return> (Enter key) event
#in other words call calcHypotenuse when calc button pressed or enter pressed
root.bind('<Return>', calcHypotenuse)   

root.title("Pythagoras v3")    #GUI title
root.geometry("400x600")    #GUI size

# create a Label and import the picture 
picture = Label(app)
picture.grid(row = 0, columnspan = 3, sticky = W)   #sticky = W means left aligned
pythagoras = PhotoImage(file = "pythagoras.gif")
picture["image"] = pythagoras

ask_lbl = Label(app, text = "This will calculate the length of the hypotenuse (c)")
ask_lbl.grid(row = 1, columnspan = 3, sticky = W)

ask_lbl = Label(app, text = "Please enter length of side a")
ask_lbl.grid(row = 2, column = 0, sticky = W)
value_a = Entry(app, width = 10)
value_a.grid(row = 2, column = 1, sticky = W)
value_a.focus_force()

ask_lbl = Label(app, text = "Please enter length of side b")
ask_lbl.grid(row = 3, column = 0, sticky = W)
value_b = Entry(app, width = 10)
value_b.grid(row = 3, column = 1, sticky = W)
value_b.focus_force()

calc = Button(app, text = "Calculate!")
calc["command"] = calcHypotenuse          #call calcHypotenuse if button clicked
calc.grid(row = 5, column = 1, sticky = W)

#box for messages and output
txt = Text(app, width = 49, height = 3, wrap = WORD, state = DISABLED)
txt.grid(row = 6, column = 0, columnspan = 3, padx = 1, pady = 1,sticky = W)

